module Gallus
  # Internal: Every log event is wrapped with this envelope. It holds information about the logger that
  # performed the operation, log level, message (or object passed) and full payload. Also includes information
  # at what time event has been recorded.
  Event = Struct.new(:logger, :level, :message, :payload) do
    attr_reader :recorded_at

    def initialize(*)
      super

      self.payload = Payload.new(payload || {})
      @recorded_at = Time.now.utc
    end
  end
end
