module Gallus
  module Format
    # Public: Simple because of implementation, not because of the output. It's default log line that contains
    # most information needed. Everything presented in a compact and easy to parse form. Example:
    #
    #   "I @ 2016-01-15T16:32:56+01:00Z $ Foo > Hello World; foo=1 bar=2"
    class SimpleLog
      def initialize(serialization = Serialization::Inspect)
        @serialization = serialization
      end

      def call(event)
        message = [ event.message, @serialization.call(event.payload) ].compact.join('; ')
        format("%s @ %s $ %s > %s", event.level.name[0], event.recorded_at.iso8601, event.logger, message)
      end
    end
  end
end
