module Gallus
  module Output
    # Public: Simple, thread-safe IO stream output handler. Takes stream and format on input.
    class Stream
      def initialize(stream, format)
        @mutex = Mutex.new
        @stream, @format = stream, format
      end

      def call(event)
        @mutex.synchronize { call!(event) }
      end

      def call!(event)
        @stream.write(@format.call(event) + "\n")
      end
    end
  end
end
