require 'forwardable'

module Gallus
  # Internal: To improve performance, context can provide values wrapped in lambdas. Those will be
  # executed at the time of writing log. Getting the values from lambdas is the job of this simple
  # payload class.
  class Payload
    include Enumerable
    extend  Forwardable

    def_delegators :@h, :empty?, :each

    def initialize(payload)
      @h = payload.inject({}) do |res,(k,v)|
        res[k.to_sym] = v.is_a?(Proc) ? v.call : v
        res
      end
    end

    def to_h
      @h
    end

    def inspect
      @h.map { |k,v| "#{k}=#{v.inspect}" }.join(" ")
    end
  end
end
